clear all;close all;clc
load StoreResponses_temperature_320reps
TEMPERATURES=0:0.1:2;
Answers=NaN(21,320,3);
for i=1:length(TEMPERATURES)
    allresponses_temperature=StoreResponses(i,:)';
    for i2=1:length(allresponses_temperature)
        response=allresponses_temperature(i2);
        response=char(response);
    
        idx1=strfind(response,'36');
        idx2=strfind(response,'37');
        idx3=strfind(response,'38');
        
        string1=response(idx1+2:idx2-2);
        string2=response(idx2+2:idx3-2);
        string3=response(idx3+2:end);
        Answers(i,i2,1)=contains(string1,'A')+10*contains(string1,'B')+100*contains(string1,'C')+1000*contains(string1,'D');
        Answers(i,i2,2)=contains(string2,'A')+10*contains(string2,'B')+100*contains(string2,'C')+1000*contains(string2,'D');
        Answers(i,i2,3)=contains(string3,'A')+10*contains(string3,'B')+100*contains(string3,'C')+1000*contains(string3,'D');
        
        if ~ismember(Answers(i,i2,1),[1 10 100 1000])
            Answers(i,i2,1)=0;
        end
        if ~ismember(Answers(i,i2,2),[1 10 100 1000])
            Answers(i,i2,2)=0;
        end
        if ~ismember(Answers(i,i2,3),[1 10 100 1000])
            Answers(i,i2,3)=0;
        end
        if Answers(i,i2,1)==0 || Answers(i,i2,2)==0 || Answers(i,i2,3)==0
        %    response
       %     pause
        end
    end
end
Answers=changem(Answers,[1 2 3 4 NaN],[1 10 100 1000 0]);

d1=Answers(:,:,1)';
d2=Answers(:,:,2)';
d3=Answers(:,:,3)';
opengl hardware
figure
plot(0:0.1:2,100*sum(d1==3)'/320,'k-o','Linewidth',3,'markersize',20,'markerfacecolor','k');hold on
plot(0:0.1:2,100*sum(d2==2)'/320,'r-s','Linewidth',3,'markersize',20,'markerfacecolor','r');hold on
plot(0:0.1:2,100*sum(d3==2)'/320,'-*','color',[255 165 0]/255,'Linewidth',3,'markersize',20);hold on

grid on
l=legend('Exam 2, Q36','Exam 2, Q37','Exam 2, Q38','location','northwest');
set(l,'Position',[0.09 0.81 0.15 0.13])
xlabel('Temperature setting')
ylabel('Percentage of responses correct')
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',32)
set(gca,'LooseInset', [0.01 0.01 0.01 0.01],'tickdir','out')
