clear all;close all;clc

d=[                         0                         1                         0                      -5.5                        -5                         0                         0
    1                       1.1                         0                      -5.4                        -4                         0                         0
    2                       1.2                         0                      -5.2                        -2                         0                         0
    3                       1.3                         0                      -5.1                        -1                         0                         0
    4                       1.4                         0                      -4.9                         1                         0                         0
    5                       1.5                         0                      -4.8                         2                         1                         1
    6                       1.6                         0                      -4.6                         4                         0                         1
    7                       1.7                         0                      -4.5                         5                         0                         1
    8                       1.9                         0                      -4.3                         7                         0                         1
    9                       2.1                         0                      -4.1                         9                         0                         1
    10                       2.2                         0                        -4                        10                         2                         3
    11                       2.4                         0                      -3.8                        12                         4                         7
    12                       2.6                         0                      -3.7                        13                         6                        13
    13                       2.8                         0                      -3.5                        15                        11                        24
    14                         3                         0                      -3.4                        16                        10                        34
    15                       3.2                         0                      -3.2                        18                        21                        55
    16                       3.3                         0                      -3.1                        19                        46                       101
    17                       3.5                         0                      -2.9                        21                        84                       185
    18                       3.7                         1                      -2.8                        22                       100                       285
    19                       3.9                         1                      -2.6                        24                       137                       422
    20                       4.1                         1                      -2.5                        25                       182                       604
    21                       4.3                         2                      -2.3                        27                       224                       828
    22                       4.4                         3                      -2.1                        29                       296                      1124
    23                       4.6                         4                        -2                        30                       431                      1555
    24                       4.8                         5                      -1.8                        32                       518                      2073
    25                         5                         7                      -1.7                        33                       590                      2663
    26                       5.2                         8                      -1.5                        35                       725                      3388
    27                       5.4                        11                      -1.4                        36                       813                      4201
    28                       5.5                        13                      -1.2                        38                       930                      5131
    29                       5.7                        16                      -1.1                        39                      1039                      6170
    30                       5.9                        19                      -0.9                        41                      1158                      7328
    31                       6.1                        22                      -0.8                        42                      1356                      8684
    32                       6.3                        26                      -0.6                        44                      1538                     10222
    33                       6.5                        31                      -0.4                        46                      1627                     11849
    34                       6.6                        36                      -0.3                        47                      1720                     13569
    35                       6.8                        41                      -0.1                        49                      1858                     15427
    36                         7                        46                         0                        50                      1948                     17375
    37                       7.2                        52                       0.2                        52                      2151                     19526
    38                       7.4                        58                       0.3                        53                      2168                     21694
    39                       7.6                        64                       0.5                        55                      2172                     23866
    40                       7.7                        70                       0.6                        56                      2164                     26030
    41                       7.9                        76                       0.8                        58                      2091                     28121
    42                       8.1                        82                       0.9                        59                      2004                     30125
    43                       8.3                        87                       1.1                        61                      1698                     31823
    44                       8.5                        91                       1.3                        63                      1467                     33290
    45                       8.7                        95                       1.4                        64                      1100                     34390
    46                       8.9                        97                       1.6                        66                       708                     35098
    47                       9.3                        99                       1.7                        67                       407                     35505
    48                       9.6                       100                       1.9                        69                       155                     35660
    49                        10                       100                         2                        70                        38                     35698];

%%
close all
figure
bar(d(:,1),d(:,6),'k', 'BarWidth', 0.8,'Linewidth',2);hold on % plot distribution of students
bar(d(37,1),d(37,6),'facecolor',[0.9 0.9 0.9],'BarWidth', 0.8,'Linewidth',2) 
bar(d(42,1),d(42,6),'facecolor',[0.45 0.45 0.45], 'BarWidth', 0.8,'Linewidth',2) 
bar(d(47,1),d(47,6),'FaceColor',[255, 165, 0]/255, 'BarWidth', 0.8,'Linewidth',2)
bar(d(45,1),d(45,6),'Facecolor',[139 0 0]/255, 'BarWidth', 0.8,'Linewidth',2)
plot([44.58 44.58],[0 2500],'-','color',[255 165 0]/255,'Linewidth',7)
plot([44.54 44.54],[0 2500],':','color',[139 0 0]/255,'Linewidth',4)
xlabel('Number of points on the exam')
ylabel('Number of students')
grid on
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',32)
legend('','GPT-3.5 - first shot','GPT-3.5 - re-prompting','GPT-4-0314','GPT-4-0613','GPT-4-0314 - bootstrapping','GPT-4-0613 - bootstrapping','location','northwest');
set(gca,'LooseInset', [0.01 0.01 0.01 0.01],'xlim',[9.4 49.6],'tickdir','out','xtick',[10 20 30 40 49])
%%
[GPT_4_0314,GPT_4_0314t]=xlsread('GPT4\ScoresGPT-4_0314.xlsx');
GPT_4_0314_1=GPT_4_0314(1:43,4:12);
GPT_4_0314_2=GPT_4_0314(1:40,19:27);
GPT_4_0314_3=GPT_4_0314(1:41,32:40);
GPT_4_0613=xlsread('GPT4\ScoresGPT-4_0613.xlsx');
GPT_4_0613_1=GPT_4_0613(1:43,4:12);
GPT_4_0613_2=GPT_4_0613(1:40,19:27);
GPT_4_0613_3=GPT_4_0613(1:41,32:40);

GPT_4_0314_A=[GPT_4_0314_1;GPT_4_0314_2;GPT_4_0314_3];GPT_4_0314_A(:,3)=[];
GPT_4_0613_A=[GPT_4_0613_1;GPT_4_0613_2;GPT_4_0613_3];GPT_4_0613_A(:,3)=[];
GPT_4_0314_A(:,end+1)=GPT_4_0314_A(:,4)./GPT_4_0314_A(:,2);
GPT_4_0613_A(:,end+1)=GPT_4_0613_A(:,4)./GPT_4_0613_A(:,2);
% 1. ChatGPT score	
% 2. Maximum possible score	
% 3. Answer incorrect (Yes = 1, No = 0)
% 4. Average score of 50 reps
% 5. Consistently correct (Yes = 1, No = 0)	
% 6. Consistently incorrect (Yes = 1, No = 0)	
% 7. Inconsistent (Yes = 1, No = 0)
% 8. Incorrect & Inconstent (i.e., own mistake identified) (Yes = 1, No = 0)
% 9. ChatGPT average score of 50 reps, normalized from 0 to 1

IncorrectOrInconsistent_0314=sign(sum(GPT_4_0314_A(1:43,[3 7]),2)); % Exam 1
IncorrectOrInconsistent_0613=sign(sum(GPT_4_0613_A(1:43,[3 7]),2)); % Exam 1
TIA=GPT_4_0314(1:43,13:14);
disp('Item difficulty - GPT-4-0314 - IncorrectOrInconsistent No vs. Yes')
meanSDoutput(TIA(IncorrectOrInconsistent_0314==0,1),TIA(IncorrectOrInconsistent_0314==1,1),1);
disp('Item difficulty - GPT-4-0613 - IncorrectOrInconsistent No vs. Yes')
meanSDoutput(TIA(IncorrectOrInconsistent_0613==0,1),TIA(IncorrectOrInconsistent_0613==1,1),1);

disp('Item-total correlation - GPT-4-0314 - IncorrectOrInconsistent No vs. Yes')
meanSDoutput(TIA(IncorrectOrInconsistent_0314==0,2),TIA(IncorrectOrInconsistent_0314==1,2),1);
disp('Item-total-correlation - GPT-4-0613 - IncorrectOrInconsistent No vs. Yes')
meanSDoutput(TIA(IncorrectOrInconsistent_0613==0,2),TIA(IncorrectOrInconsistent_0613==1,2),1);

disp('Number of questions incorrect for GPT-4-0314 and GPT-4-0613')
disp([sum(GPT_4_0314_A(:,3)) sum(GPT_4_0613_A(:,3))])
disp('Number of questions incorrect for GPT-4-0314 & GPT-4-0613')
disp([sum(GPT_4_0314_A(:,3)==1 & GPT_4_0613_A(:,3)==1)])
disp('Number of questions correct for GPT-4-0314 & incorrect for GPT-4-0613')
disp([sum(GPT_4_0314_A(:,3)==0 & GPT_4_0613_A(:,3)==1)])
disp('Number of questions incorrect for GPT-4-0314 & correct for GPT-4-0613')
disp([sum(GPT_4_0314_A(:,3)==1 & GPT_4_0613_A(:,3)==0)])

disp('Number of questions incorrect for GPT-4-0314 and GPT-4-0613')
disp([sum(GPT_4_0314_A(:,9)>0.9 & GPT_4_0613_A(:,9)<0.1)])
disp('Questions numberd with low correctness for GPT-4-0314 and high correctness for GPT-4-0613; Exam 3 Q24: GPT-4-0314: almost always C (incorrect); GPT-4-0613: always B (correct)')
disp([find(GPT_4_0314_A(:,9)<0.1 & GPT_4_0613_A(:,9)>0.9)])

